// Code generated by protoc-gen-connect-go. DO NOT EDIT.
//
// Source: connectrpc/users/v1/users.proto

package usersv1connect

import (
	connect "connectrpc.com/connect"
	context "context"
	errors "errors"
	v1 "gitlab.com/binarygame/microservices/users/pkg/gen/connectrpc/users/v1"
	http "net/http"
	strings "strings"
)

// This is a compile-time assertion to ensure that this generated file and the connect package are
// compatible. If you get a compiler error that this constant is not defined, this code was
// generated with a version of connect newer than the one compiled into your binary. You can fix the
// problem by either regenerating this code with an older version of connect or updating the connect
// version compiled into your binary.
const _ = connect.IsAtLeastVersion1_13_0

const (
	// UsersServiceName is the fully-qualified name of the UsersService service.
	UsersServiceName = "connectrpc.users.v1.UsersService"
)

// These constants are the fully-qualified names of the RPCs defined in this package. They're
// exposed at runtime as Spec.Procedure and as the final two segments of the HTTP route.
//
// Note that these are different from the fully-qualified method names used by
// google.golang.org/protobuf/reflect/protoreflect. To convert from these constants to
// reflection-formatted method names, remove the leading slash and convert the remaining slash to a
// period.
const (
	// UsersServiceAddUserProcedure is the fully-qualified name of the UsersService's AddUser RPC.
	UsersServiceAddUserProcedure = "/connectrpc.users.v1.UsersService/AddUser"
	// UsersServiceEditUserProcedure is the fully-qualified name of the UsersService's EditUser RPC.
	UsersServiceEditUserProcedure = "/connectrpc.users.v1.UsersService/EditUser"
	// UsersServiceGetAllowedEmojisProcedure is the fully-qualified name of the UsersService's
	// GetAllowedEmojis RPC.
	UsersServiceGetAllowedEmojisProcedure = "/connectrpc.users.v1.UsersService/GetAllowedEmojis"
	// UsersServiceGetUsersProcedure is the fully-qualified name of the UsersService's GetUsers RPC.
	UsersServiceGetUsersProcedure = "/connectrpc.users.v1.UsersService/GetUsers"
	// UsersServiceGetUserProcedure is the fully-qualified name of the UsersService's GetUser RPC.
	UsersServiceGetUserProcedure = "/connectrpc.users.v1.UsersService/GetUser"
)

// These variables are the protoreflect.Descriptor objects for the RPCs defined in this package.
var (
	usersServiceServiceDescriptor                = v1.File_connectrpc_users_v1_users_proto.Services().ByName("UsersService")
	usersServiceAddUserMethodDescriptor          = usersServiceServiceDescriptor.Methods().ByName("AddUser")
	usersServiceEditUserMethodDescriptor         = usersServiceServiceDescriptor.Methods().ByName("EditUser")
	usersServiceGetAllowedEmojisMethodDescriptor = usersServiceServiceDescriptor.Methods().ByName("GetAllowedEmojis")
	usersServiceGetUsersMethodDescriptor         = usersServiceServiceDescriptor.Methods().ByName("GetUsers")
	usersServiceGetUserMethodDescriptor          = usersServiceServiceDescriptor.Methods().ByName("GetUser")
)

// UsersServiceClient is a client for the connectrpc.users.v1.UsersService service.
type UsersServiceClient interface {
	AddUser(context.Context, *connect.Request[v1.AddUserRequest]) (*connect.Response[v1.AddUserResponse], error)
	EditUser(context.Context, *connect.Request[v1.EditUserRequest]) (*connect.Response[v1.EditUserResponse], error)
	GetAllowedEmojis(context.Context, *connect.Request[v1.GetAllowedEmojisRequest]) (*connect.Response[v1.GetAllowedEmojisResponse], error)
	// Gets user data from a list of user IDs.
	GetUsers(context.Context, *connect.Request[v1.GetUsersRequest]) (*connect.Response[v1.GetUsersResponse], error)
	// Gets a single user's data
	GetUser(context.Context, *connect.Request[v1.GetUserRequest]) (*connect.Response[v1.GetUserResponse], error)
}

// NewUsersServiceClient constructs a client for the connectrpc.users.v1.UsersService service. By
// default, it uses the Connect protocol with the binary Protobuf Codec, asks for gzipped responses,
// and sends uncompressed requests. To use the gRPC or gRPC-Web protocols, supply the
// connect.WithGRPC() or connect.WithGRPCWeb() options.
//
// The URL supplied here should be the base URL for the Connect or gRPC server (for example,
// http://api.acme.com or https://acme.com/grpc).
func NewUsersServiceClient(httpClient connect.HTTPClient, baseURL string, opts ...connect.ClientOption) UsersServiceClient {
	baseURL = strings.TrimRight(baseURL, "/")
	return &usersServiceClient{
		addUser: connect.NewClient[v1.AddUserRequest, v1.AddUserResponse](
			httpClient,
			baseURL+UsersServiceAddUserProcedure,
			connect.WithSchema(usersServiceAddUserMethodDescriptor),
			connect.WithClientOptions(opts...),
		),
		editUser: connect.NewClient[v1.EditUserRequest, v1.EditUserResponse](
			httpClient,
			baseURL+UsersServiceEditUserProcedure,
			connect.WithSchema(usersServiceEditUserMethodDescriptor),
			connect.WithClientOptions(opts...),
		),
		getAllowedEmojis: connect.NewClient[v1.GetAllowedEmojisRequest, v1.GetAllowedEmojisResponse](
			httpClient,
			baseURL+UsersServiceGetAllowedEmojisProcedure,
			connect.WithSchema(usersServiceGetAllowedEmojisMethodDescriptor),
			connect.WithClientOptions(opts...),
		),
		getUsers: connect.NewClient[v1.GetUsersRequest, v1.GetUsersResponse](
			httpClient,
			baseURL+UsersServiceGetUsersProcedure,
			connect.WithSchema(usersServiceGetUsersMethodDescriptor),
			connect.WithClientOptions(opts...),
		),
		getUser: connect.NewClient[v1.GetUserRequest, v1.GetUserResponse](
			httpClient,
			baseURL+UsersServiceGetUserProcedure,
			connect.WithSchema(usersServiceGetUserMethodDescriptor),
			connect.WithClientOptions(opts...),
		),
	}
}

// usersServiceClient implements UsersServiceClient.
type usersServiceClient struct {
	addUser          *connect.Client[v1.AddUserRequest, v1.AddUserResponse]
	editUser         *connect.Client[v1.EditUserRequest, v1.EditUserResponse]
	getAllowedEmojis *connect.Client[v1.GetAllowedEmojisRequest, v1.GetAllowedEmojisResponse]
	getUsers         *connect.Client[v1.GetUsersRequest, v1.GetUsersResponse]
	getUser          *connect.Client[v1.GetUserRequest, v1.GetUserResponse]
}

// AddUser calls connectrpc.users.v1.UsersService.AddUser.
func (c *usersServiceClient) AddUser(ctx context.Context, req *connect.Request[v1.AddUserRequest]) (*connect.Response[v1.AddUserResponse], error) {
	return c.addUser.CallUnary(ctx, req)
}

// EditUser calls connectrpc.users.v1.UsersService.EditUser.
func (c *usersServiceClient) EditUser(ctx context.Context, req *connect.Request[v1.EditUserRequest]) (*connect.Response[v1.EditUserResponse], error) {
	return c.editUser.CallUnary(ctx, req)
}

// GetAllowedEmojis calls connectrpc.users.v1.UsersService.GetAllowedEmojis.
func (c *usersServiceClient) GetAllowedEmojis(ctx context.Context, req *connect.Request[v1.GetAllowedEmojisRequest]) (*connect.Response[v1.GetAllowedEmojisResponse], error) {
	return c.getAllowedEmojis.CallUnary(ctx, req)
}

// GetUsers calls connectrpc.users.v1.UsersService.GetUsers.
func (c *usersServiceClient) GetUsers(ctx context.Context, req *connect.Request[v1.GetUsersRequest]) (*connect.Response[v1.GetUsersResponse], error) {
	return c.getUsers.CallUnary(ctx, req)
}

// GetUser calls connectrpc.users.v1.UsersService.GetUser.
func (c *usersServiceClient) GetUser(ctx context.Context, req *connect.Request[v1.GetUserRequest]) (*connect.Response[v1.GetUserResponse], error) {
	return c.getUser.CallUnary(ctx, req)
}

// UsersServiceHandler is an implementation of the connectrpc.users.v1.UsersService service.
type UsersServiceHandler interface {
	AddUser(context.Context, *connect.Request[v1.AddUserRequest]) (*connect.Response[v1.AddUserResponse], error)
	EditUser(context.Context, *connect.Request[v1.EditUserRequest]) (*connect.Response[v1.EditUserResponse], error)
	GetAllowedEmojis(context.Context, *connect.Request[v1.GetAllowedEmojisRequest]) (*connect.Response[v1.GetAllowedEmojisResponse], error)
	// Gets user data from a list of user IDs.
	GetUsers(context.Context, *connect.Request[v1.GetUsersRequest]) (*connect.Response[v1.GetUsersResponse], error)
	// Gets a single user's data
	GetUser(context.Context, *connect.Request[v1.GetUserRequest]) (*connect.Response[v1.GetUserResponse], error)
}

// NewUsersServiceHandler builds an HTTP handler from the service implementation. It returns the
// path on which to mount the handler and the handler itself.
//
// By default, handlers support the Connect, gRPC, and gRPC-Web protocols with the binary Protobuf
// and JSON codecs. They also support gzip compression.
func NewUsersServiceHandler(svc UsersServiceHandler, opts ...connect.HandlerOption) (string, http.Handler) {
	usersServiceAddUserHandler := connect.NewUnaryHandler(
		UsersServiceAddUserProcedure,
		svc.AddUser,
		connect.WithSchema(usersServiceAddUserMethodDescriptor),
		connect.WithHandlerOptions(opts...),
	)
	usersServiceEditUserHandler := connect.NewUnaryHandler(
		UsersServiceEditUserProcedure,
		svc.EditUser,
		connect.WithSchema(usersServiceEditUserMethodDescriptor),
		connect.WithHandlerOptions(opts...),
	)
	usersServiceGetAllowedEmojisHandler := connect.NewUnaryHandler(
		UsersServiceGetAllowedEmojisProcedure,
		svc.GetAllowedEmojis,
		connect.WithSchema(usersServiceGetAllowedEmojisMethodDescriptor),
		connect.WithHandlerOptions(opts...),
	)
	usersServiceGetUsersHandler := connect.NewUnaryHandler(
		UsersServiceGetUsersProcedure,
		svc.GetUsers,
		connect.WithSchema(usersServiceGetUsersMethodDescriptor),
		connect.WithHandlerOptions(opts...),
	)
	usersServiceGetUserHandler := connect.NewUnaryHandler(
		UsersServiceGetUserProcedure,
		svc.GetUser,
		connect.WithSchema(usersServiceGetUserMethodDescriptor),
		connect.WithHandlerOptions(opts...),
	)
	return "/connectrpc.users.v1.UsersService/", http.HandlerFunc(func(w http.ResponseWriter, r *http.Request) {
		switch r.URL.Path {
		case UsersServiceAddUserProcedure:
			usersServiceAddUserHandler.ServeHTTP(w, r)
		case UsersServiceEditUserProcedure:
			usersServiceEditUserHandler.ServeHTTP(w, r)
		case UsersServiceGetAllowedEmojisProcedure:
			usersServiceGetAllowedEmojisHandler.ServeHTTP(w, r)
		case UsersServiceGetUsersProcedure:
			usersServiceGetUsersHandler.ServeHTTP(w, r)
		case UsersServiceGetUserProcedure:
			usersServiceGetUserHandler.ServeHTTP(w, r)
		default:
			http.NotFound(w, r)
		}
	})
}

// UnimplementedUsersServiceHandler returns CodeUnimplemented from all methods.
type UnimplementedUsersServiceHandler struct{}

func (UnimplementedUsersServiceHandler) AddUser(context.Context, *connect.Request[v1.AddUserRequest]) (*connect.Response[v1.AddUserResponse], error) {
	return nil, connect.NewError(connect.CodeUnimplemented, errors.New("connectrpc.users.v1.UsersService.AddUser is not implemented"))
}

func (UnimplementedUsersServiceHandler) EditUser(context.Context, *connect.Request[v1.EditUserRequest]) (*connect.Response[v1.EditUserResponse], error) {
	return nil, connect.NewError(connect.CodeUnimplemented, errors.New("connectrpc.users.v1.UsersService.EditUser is not implemented"))
}

func (UnimplementedUsersServiceHandler) GetAllowedEmojis(context.Context, *connect.Request[v1.GetAllowedEmojisRequest]) (*connect.Response[v1.GetAllowedEmojisResponse], error) {
	return nil, connect.NewError(connect.CodeUnimplemented, errors.New("connectrpc.users.v1.UsersService.GetAllowedEmojis is not implemented"))
}

func (UnimplementedUsersServiceHandler) GetUsers(context.Context, *connect.Request[v1.GetUsersRequest]) (*connect.Response[v1.GetUsersResponse], error) {
	return nil, connect.NewError(connect.CodeUnimplemented, errors.New("connectrpc.users.v1.UsersService.GetUsers is not implemented"))
}

func (UnimplementedUsersServiceHandler) GetUser(context.Context, *connect.Request[v1.GetUserRequest]) (*connect.Response[v1.GetUserResponse], error) {
	return nil, connect.NewError(connect.CodeUnimplemented, errors.New("connectrpc.users.v1.UsersService.GetUser is not implemented"))
}
